"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const commit_helper_service_1 = require("./../services/commit-helper.service");
class CommitControl {
    constructor() {
        this.commit = new commit_helper_service_1.CommitHelperService();
    }
    init(isTag) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const message = yield this.commit.getCommitMessage();
            if (!isTag) {
                resolve({
                    commit: message.status
                        ? message.data
                        : { message: '获取提交信息失败', date: '获取提交日期失败', commit: '获取提交hash失败' }
                });
            }
            else {
                const version = yield this.commit.getPackageVersion();
                resolve({
                    commit: message.status
                        ? message.data
                        : { message: '获取提交信息失败', date: '获取提交日期失败', commit: '获取提交hash失败' },
                    version: version.status ? version.data : ''
                });
            }
        }));
    }
}
exports.CommitControl = CommitControl;
