"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_tool_1 = require("./../utils/path.tool");
const cdn_helper_1 = require("../models/cdn.helper");
const git_helper_1 = require("../models/git.helper");
const file_tool_1 = require("../utils/file.tool");
const colors_1 = __importDefault(require("colors"));
const inquirer_1 = __importDefault(require("inquirer"));
class CreateHelperControl {
    constructor(type) {
        this.fileTool = new file_tool_1.FileTool();
        this.pathTool = new path_tool_1.PathTool();
        this.config = git_helper_1.git;
        this.filepath = this.pathTool.createPath('./github.helper.json');
        if (type === 'c') {
            this.filepath = this.pathTool.createPath('./cdn.helper.json');
            this.config = cdn_helper_1.cdn;
        }
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            const read = yield this.fileTool.read(this.filepath);
            if (read.status) {
                console.log(colors_1.default.red(`文件 ${this.filepath} 已存在`));
                console.log(``);
            }
            inquirer_1.default
                .prompt([
                {
                    type: 'input',
                    name: 'isAdd',
                    message: `是否添加 ${this.filepath} 文件 ?(Y/N || y/n)`.magenta,
                    validate: (input) => {
                        if (input === 'N' || input === 'Y' || input === 'n' || input === 'y' || !input) {
                            return true;
                        }
                        return '输入不合法，请输入 Y/N 或 y/n'.red;
                    }
                }
            ])
                .then((answers) => __awaiter(this, void 0, void 0, function* () {
                if (answers.isAdd === 'y' || answers.isAdd === 'Y') {
                    const write = yield this.fileTool.write(this.filepath, this.config);
                    return;
                }
                console.log(`取消创建 ${this.filepath} 文件`.yellow);
                console.log(``);
            }));
        });
    }
}
exports.CreateHelperControl = CreateHelperControl;
