"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_tool_1 = require("./../utils/path.tool");
const build_helper_service_1 = require("./../services/build-helper.service");
const colors_1 = __importDefault(require("colors"));
const open_1 = __importDefault(require("open"));
class GitEndControl {
    constructor() {
        this.buildHelper = new build_helper_service_1.BuildHelperService();
        this.pathTool = new path_tool_1.PathTool();
    }
    init(env, open) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const config = yield this.buildHelper.checkGithub(env);
            if (config.status) {
                const clean = yield this.buildHelper.cleanPush(this.pathTool.createPath('./push/'), config.data.dirname ? config.data.dirname : '');
                if (clean.status) {
                    const copy = yield this.buildHelper.copyPush(config.data.dirname ? config.data.dirname : '');
                    if (copy.status) {
                        const add = yield this.buildHelper.addPush(this.pathTool.createPath('./push/'));
                        if (add.status) {
                            const commit = yield this.buildHelper.commitPush(this.pathTool.createPath());
                            if (commit.status) {
                                const push = yield this.buildHelper.donePush(this.pathTool.createPath(), config.data.branch);
                                if (push.status) {
                                    const remove = yield this.buildHelper.removePush();
                                    if (!remove.status) {
                                        console.log(colors_1.default.yellow(`删除push目录失败，请稍后手动删除`));
                                        console.log(``);
                                    }
                                    if (open) {
                                        this.open(config.data.remote);
                                    }
                                    resolve({ status: true });
                                }
                                else {
                                    resolve({ status: false });
                                }
                            }
                            else {
                                resolve({ status: false });
                            }
                        }
                        else {
                            resolve({ status: false });
                        }
                    }
                    else {
                        resolve({ status: false });
                    }
                }
                else {
                    resolve({ status: false });
                }
            }
            else {
                console.log(colors_1.default.red(`获取 ${env} 配置失败，请检查github.helper.json文件`));
                resolve({ status: false });
            }
        }));
    }
    open(remote) {
        let url;
        if (remote.indexOf('http') > -1) {
            url = remote.replace('http', 'https');
            url = url.replace('httpss', 'https');
            url = url.replace('.git', '');
        }
        else {
            if (remote.indexOf('git@ssh-') > -1) {
                /* gitlab */
                url = remote.replace(':', '/');
                url = url.replace('git@ssh-', 'https://');
                url = url.replace('.git', '');
            }
            else {
                /* github */
                url = remote.replace(':', '/');
                url = url.replace('git@', 'https://');
                url = url.replace('.git', '');
            }
        }
        if (url) {
            console.log(`打开发布地址: ${url}`.green);
            open_1.default(url);
        }
        else {
            console.log(`打开发布地址失败: ${remote}`.red);
        }
    }
}
exports.GitEndControl = GitEndControl;
