"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const build_helper_service_1 = require("./../services/build-helper.service");
const colors_1 = __importDefault(require("colors"));
class GitStartControl {
    constructor() {
        this.buildHelper = new build_helper_service_1.BuildHelperService();
    }
    init(env) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const config = yield this.buildHelper.checkGithub(env);
            if (config.status) {
                const clone = yield this.buildHelper.clonePushGit(config.data.remote, config.data.branch);
                if (clone.status) {
                    const ignore = yield this.buildHelper.ignorePush(config.data.ignore ? config.data.ignore : []);
                    if (!ignore.status) {
                        console.log(colors_1.default.yellow(`未添加 .gitignore 文件`));
                    }
                    else {
                        console.log(colors_1.default.green(`添加 .gitignore 文件成功`));
                        resolve(ignore);
                    }
                }
                else {
                    resolve({ status: false });
                }
            }
            else {
                console.log(colors_1.default.red(`获取 ${env} 配置失败，请检查github.helper.json文件`));
                resolve({ status: false });
            }
        }));
    }
}
exports.GitStartControl = GitStartControl;
