"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const exec_tool_1 = require("./../utils/exec.tool");
const colors_1 = __importDefault(require("colors"));
class InitControl {
    constructor(cloneOrder, execPath) {
        this.cloneExec = new exec_tool_1.ExecTool(cloneOrder, execPath);
        this.fileName = this.getFileName(cloneOrder);
        if (cloneOrder.indexOf(`https://gitlab.jpushoa.com/front-end/ad-frontend-base-react`) > -1) {
            this.removeExec = new exec_tool_1.ExecTool(`rm -rf .git`, execPath + `/${this.fileName}`);
        }
        else {
            console.log(colors_1.default.yellow(`完成init任务后，可能需要在 ${this.fileName} 目录下手动执行 rm -rf .git 删除git仓库！`));
        }
        this.installExec = new exec_tool_1.ExecTool(`npm install`, execPath + `/${this.fileName}`);
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            const clone = yield this.cloneExec.run();
            if (clone.status) {
                if (this.removeExec) {
                    const remove = yield this.removeExec.run();
                }
                const install = yield this.installExec.run();
                console.log(colors_1.default.yellow(`初始化任务执行完毕，请执行 cd ${this.fileName}/ 进入工程目录`));
            }
        });
    }
    getFileName(cloneOrder) {
        const names = cloneOrder.split('/');
        if (cloneOrder.indexOf('.git') > -1) {
            const regValue = cloneOrder.match(/\.git(.*)/);
            if (!regValue) {
                return names[names.length - 1].replace('.git', '');
            }
            if (!regValue[1]) {
                return names[names.length - 1].replace('.git', '');
            }
            if (regValue[1]) {
                return regValue[1].replace(' ', '');
            }
        }
        return names[names.length - 1].split(' ')[1];
    }
}
exports.InitControl = InitControl;
