"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const upload_helper_service_1 = require("./../services/upload-helper.service");
const build_helper_service_1 = require("./../services/build-helper.service");
class UploadControl {
    constructor() {
        this.buildHelper = new build_helper_service_1.BuildHelperService();
        this.uploadHelperService = new upload_helper_service_1.UploadHelperService();
    }
    init(env) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const config = yield this.buildHelper.checkCdn(env);
            if (!config.status) {
                resolve(config);
            }
            else {
                const files = yield this.uploadHelperService.createUploadList(config.data);
                if (!files.status) {
                    resolve(files);
                }
                else {
                    const uploader = yield this.uploadHelperService.upload(config.data, files.data);
                    resolve(uploader);
                }
            }
        }));
    }
}
exports.UploadControl = UploadControl;
