"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_tool_1 = require("./../utils/path.tool");
const file_tool_1 = require("./../utils/file.tool");
const exec_tool_1 = require("../utils/exec.tool");
class CommitHelperService {
    constructor() {
        this.commit = new exec_tool_1.ExecTool(`git log -1 \
    --date=iso --pretty=format:'{"message": "%s","date": "%ad","commit": "%H"},' \
    $@ | \
    perl -pe 'BEGIN{print "["}; END{print "]\n"}' | \
    perl -pe 's/},]/}]/'`);
        this.patch = new exec_tool_1.ExecTool(`npm version patch`);
        this.version = new file_tool_1.FileTool();
        this.pathTool = new path_tool_1.PathTool();
    }
    getCommitMessage() {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const commit = yield this.commit.run();
            resolve(commit);
        }));
    }
    getPackageVersion() {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const patch = yield this.patch.run();
            const path = this.pathTool.createPath('./package.json');
            const packge = yield this.version.read(path);
            if (packge.status) {
                resolve({
                    status: true,
                    data: packge.data.version ? packge.data.version : '获取package版本号失败'
                });
            }
            else {
                resolve({
                    status: false
                });
            }
        }));
    }
}
exports.CommitHelperService = CommitHelperService;
