"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_tool_1 = require("../utils/path.tool");
const file_tool_1 = require("../utils/file.tool");
class ConfigHelperService {
    constructor() {
        this.fileTool = new file_tool_1.FileTool();
        this.pathTool = new path_tool_1.PathTool();
    }
    getConfigByType(type) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            let filePath = '';
            if (type === 'g') {
                filePath = this.pathTool.createPath('./github.helper.json');
            }
            if (type === 'c') {
                filePath = this.pathTool.createPath('./cdn.helper.json');
            }
            const res = yield this.fileTool.read(filePath);
            resolve(res);
        }));
    }
}
exports.ConfigHelperService = ConfigHelperService;
