"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const qiniu_tool_1 = require("./../utils/qiniu.tool");
const path_tool_1 = require("./../utils/path.tool");
const glob_1 = __importDefault(require("glob"));
const colors_1 = __importDefault(require("colors"));
class UploadHelperService {
    constructor() {
        this.pathTool = new path_tool_1.PathTool();
        this.uploadTool = new qiniu_tool_1.UploadTool();
    }
    createUploadList(cdn) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            glob_1.default(`${this.pathTool.createPath('./build')}/**`, { nodir: true }, (err, files) => {
                if (err) {
                    resolve({
                        status: false,
                        data: []
                    });
                }
                else {
                    const list = [];
                    files.forEach((file, index) => {
                        if (cdn.ignore && cdn.ignore.length > 0) {
                            cdn.ignore.forEach((item, s) => {
                                if (file.indexOf(item.replace('*', '')) == -1) {
                                    const a = file.split('build');
                                    let key = '';
                                    if (cdn.dirname) {
                                        key = `${cdn.dirname}/`;
                                    }
                                    if (cdn.v) {
                                        key = key ? `${key}/${cdn.v}/` : `${cdn.v}/`;
                                    }
                                    if (key) {
                                        key = key + a[1];
                                    }
                                    else {
                                        key = a[1];
                                    }
                                    list.push({
                                        path: file,
                                        key: key
                                    });
                                }
                            });
                        }
                        else {
                            const a = file.split('/');
                            let key = '';
                            if (cdn.dirname) {
                                key = `${cdn.dirname}/`;
                            }
                            if (cdn.v) {
                                key = key ? `${key}/${cdn.v}/` : `${cdn.v}/`;
                            }
                            if (key) {
                                key = key + a[a.length - 1];
                            }
                            else {
                                key = a[a.length - 1];
                            }
                            list.push({
                                path: file,
                                key: key
                            });
                        }
                    });
                    resolve({
                        status: true,
                        data: list
                    });
                }
            });
        }));
    }
    upload(cdn, list) {
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            console.log(colors_1.default.cyan(`需要上传文件总数：${list.length}`));
            const token = this.uploadTool.getToken(cdn);
            list.forEach((file, index) => {
                this.uploadTool.upload(token, file.key, file, cdn.url, cdn.zone);
            });
            resolve({
                status: true
            });
        }));
    }
}
exports.UploadHelperService = UploadHelperService;
