"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const colors_1 = __importDefault(require("colors"));
const shelljs_1 = __importDefault(require("shelljs"));
class ExecTool {
    constructor(order, path) {
        this.order = '';
        this.path = '';
        this.order = order;
        if (path) {
            this.path = path;
        }
    }
    run() {
        return new Promise((resolve, reject) => {
            if (!this.order) {
                console.log(colors_1.default.red(`执行命令不能为空！`));
                resolve({
                    status: false
                });
            }
            else {
                if (this.path) {
                    shelljs_1.default.cd(this.path);
                    console.log(`执行路径 ${this.path}`.cyan);
                }
                console.log(colors_1.default.yellow(`开始执行 ${this.order} 命令`));
                const exec = shelljs_1.default.exec(this.order, { async: true }, (code, stdout, stderr) => {
                    if (code === 0) {
                        console.log(colors_1.default.green(`命令 ${this.order} 执行完成`));
                        console.log(``);
                        let data = stdout;
                        try {
                            data = JSON.parse(stdout)[0];
                        }
                        catch (error) { }
                        resolve({
                            status: true,
                            data: data
                        });
                    }
                    else {
                        console.log(colors_1.default.red(`执行 ${this.order} 任务出错， 错误码: ${code}`));
                        console.log(``);
                        resolve({
                            status: false
                        });
                    }
                });
                exec.stdout.on('data', (data) => {
                    /* shelljs会自动输入执行内容 */
                    // console.log(colors_1.default.white(data));
                });
                exec.stderr.on('data', (error) => {
                    /* shelljs会自动输入执行内容 */
                    // console.log(colors.yellow(error));
                });
            }
        });
    }
}
exports.ExecTool = ExecTool;
