"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const colors_1 = __importDefault(require("colors"));
class FileTool {
    read(filepath) {
        return new Promise((resolve) => {
            console.log(colors_1.default.yellow(`开始读取 ${filepath} 文件`));
            fs_1.default.readFile(filepath, (err, data) => {
                if (err) {
                    console.log(colors_1.default.red(`读取 ${filepath} 文件失败`));
                    resolve({
                        status: false,
                        data: err
                    });
                }
                else {
                    console.log(colors_1.default.green(`读取 ${filepath} 文件完毕`));
                    resolve({
                        status: true,
                        data: this.reduceData(data, true)
                    });
                }
            });
        });
    }
    write(filepath, data) {
        return new Promise((resolve) => {
            console.log(colors_1.default.yellow(`开始写入 ${filepath} 文件`));
            fs_1.default.writeFile(filepath, this.reduceData(data), (err) => {
                if (err) {
                    console.log(colors_1.default.red(`写入 ${filepath} 文件失败`));
                    console.log(``);
                    resolve({
                        status: false
                    });
                }
                else {
                    console.log(colors_1.default.green(`写入 ${filepath} 文件完毕`));
                    console.log(``);
                    resolve({
                        status: true,
                        data: this.reduceData(data)
                    });
                }
            });
        });
    }
    reduceData(data, isRead) {
        let value = data;
        if (!isRead) {
            try {
                if (typeof data !== 'string') {
                    value = JSON.stringify(data);
                }
            }
            catch (error) {
                value = data;
            }
        }
        if (isRead) {
            try {
                value = JSON.parse(data);
            }
            catch (error) {
                value = data;
            }
        }
        return value;
    }
}
exports.FileTool = FileTool;
