"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const qiniu_1 = __importDefault(require("qiniu"));
const colors_1 = __importDefault(require("colors"));
class UploadTool {
    getToken(cdn) {
        const mac = new qiniu_1.default.auth.digest.Mac(cdn.ak, cdn.sk);
        const options = {
            scope: cdn.bk
        };
        const putPolicy = new qiniu_1.default.rs.PutPolicy(options);
        const uploadToken = putPolicy.uploadToken(mac);
        return uploadToken;
    }
    upload(token, key, file, url, zone) {
        return new Promise((resolve) => {
            const config = new qiniu_1.default.conf.Config();
            const qzone = qiniu_1.default.zone;
            if (zone && qiniu_1.default.zone && qzone[zone]) {
                config.zone = qzone[zone];
            }
            const putExtra = new qiniu_1.default.form_up.PutExtra();
            const formUploader = new qiniu_1.default.form_up.FormUploader(config);
            formUploader.putFile(token, key, file, putExtra, (respErr, respBody, respInfo) => {
                if (respErr) {
                    console.log(`错误信息`.red);
                    console.log(colors_1.default.yellow(respErr));
                    console.log(``);
                    resolve({
                        status: false
                    });
                }
                if (respInfo) {
                    if (respInfo.statusCode == 200) {
                        console.log(colors_1.default.green(`上传 ${url ? url : '~'}/${respBody.key} 完成`));
                    }
                    else {
                        console.log(`Waring code: ${respInfo.statusCode}`.yellow);
                        console.log(colors_1.default.white(respBody));
                        console.log(``);
                    }
                    resolve({
                        status: true
                    });
                }
            });
        });
    }
}
exports.UploadTool = UploadTool;
