import { CommitHelperService } from './../services/commit-helper.service';

export class CommitControl {
    private commit: CommitHelperService = new CommitHelperService();
    constructor() {}
    public init(isTag: boolean): Promise<{ commit: any; version?: string }> {
        return new Promise(async (resolve) => {
            const message = await this.commit.getCommitMessage();
            if (!isTag) {
                resolve({
                    commit: message.status
                        ? message.data
                        : { message: '获取提交信息失败', date: '获取提交日期失败', commit: '获取提交hash失败' }
                });
            } else {
                const version = await this.commit.getPackageVersion();
                resolve({
                    commit: message.status
                        ? message.data
                        : { message: '获取提交信息失败', date: '获取提交日期失败', commit: '获取提交hash失败' },
                    version: version.status ? version.data : ''
                });
            }
        });
    }
}
