import { PathTool } from './../utils/path.tool';
import { cdn } from '../models/cdn.helper';
import { git } from '../models/git.helper';
import { FileTool } from '../utils/file.tool';
import colors from 'colors';
import inquirer from 'inquirer';

export class CreateHelperControl {
    private fileTool: FileTool = new FileTool();
    private pathTool: PathTool = new PathTool();
    private config: any = git;
    private filepath = this.pathTool.createPath('./github.helper.json');
    constructor(type?: string) {
        if (type === 'c') {
            this.filepath = this.pathTool.createPath('./cdn.helper.json');
            this.config = cdn;
        }
    }
    public async init() {
        const read = await this.fileTool.read(this.filepath);
        if (read.status) {
            console.log(colors.red(`文件 ${this.filepath} 已存在`));
            console.log(``)
        }
        inquirer
            .prompt([
                {
                    type: 'input',
                    name: 'isAdd',
                    message: `是否添加 ${this.filepath} 文件 ?(Y/N || y/n)`.magenta,
                    validate: (input: string) => {
                        if (input === 'N' || input === 'Y' || input === 'n' || input === 'y' || !input) {
                            return true;
                        }
                        return '输入不合法，请输入 Y/N 或 y/n'.red;
                    }
                }
            ])
            .then(async (answers: any) => {
                if (answers.isAdd === 'y' || answers.isAdd === 'Y') {
                    const write = await this.fileTool.write(this.filepath, this.config);
                    return;
                }
                console.log(`取消创建 ${this.filepath} 文件`.yellow);
                console.log(``);
            });
    }
}
