import { BuildHelperService } from './../services/build-helper.service';
import colors from 'colors';

export class GitStartControl {
    private buildHelper: BuildHelperService = new BuildHelperService();
    constructor() {}
    public init(env: string): Promise<any> {
        return new Promise(async (resolve) => {
            const config = await this.buildHelper.checkGithub(env);
            if (config.status) {
                const clone = await this.buildHelper.clonePushGit(config.data.remote,config.data.branch);
                if(clone.status){
                    const ignore = await this.buildHelper.ignorePush(config.data.ignore?config.data.ignore:[]);
                    if(!ignore.status){
                        console.log(colors.yellow(`未添加 .gitignore 文件`));
                    }else{
                        console.log(colors.green(`添加 .gitignore 文件成功`));
                        resolve(ignore);
                    }
                }else{
                    resolve({ status: false });
                }
            } else {
                console.log(colors.red(`获取 ${env} 配置失败，请检查github.helper.json文件`));
                resolve({ status: false });
            }
        });
    }
}
