import { UploadHelperService } from './../services/upload-helper.service';
import { BuildHelperService } from './../services/build-helper.service';

export class UploadControl {
    private buildHelper: BuildHelperService = new BuildHelperService();
    private uploadHelperService: UploadHelperService = new UploadHelperService();
    constructor() {}
    public init(env: string): Promise<any> {
        return new Promise(async (resolve) => {
            const config = await this.buildHelper.checkCdn(env);
            if (!config.status) {
                resolve(config);
            } else {
                const files = await this.uploadHelperService.createUploadList(config.data);
                if (!files.status) {
                    resolve(files);
                } else {
                    const uploader = await this.uploadHelperService.upload(config.data, files.data);
                    resolve(uploader);
                }
            }
        });
    }
}
