import colors from 'colors';
import program from 'commander';

import * as packgeConfig from '../package.json';
program
    .version(packgeConfig.version)
    .option(
        '-t, --type [value]',
        `choose type，
        c cdn.helper.json //only support 七牛 https://www.qiniu.com/, 
        g github.helper.json
        默认为 g
        `,
        'g'
    )
    .option('-e, --env [value]', `env默认production`, 'production')
    .option(
        '-a, --autopatch [value]',
        `选择是否给源代码打tag和升级版本号，默认关闭
        false //关闭给源代码打tag和升级版本号的功能, 
        true //开启给源代码打tag和升级版本号的功能`,
        false
    )
    .option(
        '-o, --open [value]',
        `选择打包完成后是否自动打开发布页面的功能，默认开启
        false //关闭发布完成后自动打开发布页的功能, 
        true //开启发布完成后自动打开发布页的功能`,
        true
    )
    .option(
        '-m, --message [value]',
        `发布时提交信息类型 默认为源代码版本信息+commit信息
        version //源代码版本信息+commit信息, 
        commit //只有源代码最新的提交信息`,
        'version'
    )
    .option(
        '-s, --show [value]',
        `是否给build出来的项目 添加调试信息，项目控制台会输出提交信息 默认关闭
        false //关闭添加调试信息功能, 
        true //开启添加调试信息功能`,
        false
    )
    .option(
        '-u, --url [value]',
        `初始化项目仓库地址，默认为jpush内部仓库地址，外网无法访问`,
        'https://gitlab.jpushoa.com/front-end/ad-frontend-base-react'
    ).option(
        '-p, --path [value]',
        `命令执行目录，不推荐使用`
    ).option(
        '-n, --filename [value]',
        `初始化仓库目录名称`
    )
    .usage('<keywords>')
    .parse(process.argv);
export = program;
