import { PathTool } from './../utils/path.tool';
import { FileTool } from './../utils/file.tool';
import { ExecTool } from '../utils/exec.tool';

export class CommitHelperService {
    private commit: ExecTool = new ExecTool(`git log -1 \
    --date=iso --pretty=format:'{"message": "%s","date": "%ad","commit": "%H"},' \
    $@ | \
    perl -pe 'BEGIN{print "["}; END{print "]\n"}' | \
    perl -pe 's/},]/}]/'`);
    private patch: ExecTool = new ExecTool(`npm version patch`);
    private version: FileTool = new FileTool();
    private pathTool: PathTool = new PathTool();
    public getCommitMessage(): Promise<any> {
        return new Promise(async (resolve) => {
            const commit = await this.commit.run();
            resolve(commit);
        });
    }
    public getPackageVersion(): Promise<any> {
        return new Promise(async (resolve) => {
            const patch = await this.patch.run();
            const path = this.pathTool.createPath('./package.json');
            const packge = await this.version.read(path);
            if (packge.status) {
                resolve({
                    status: true,
                    data: packge.data.version ? packge.data.version : '获取package版本号失败'
                });
            } else {
                resolve({
                    status: false
                });
            }
        });
    }
}
