import { UploadTool } from './../utils/qiniu.tool';
import { PathTool } from './../utils/path.tool';
import glob from 'glob';
import colors from 'colors';

export class UploadHelperService {
    private pathTool: PathTool = new PathTool();
    private uploadTool: UploadTool = new UploadTool();
    public createUploadList(cdn: any): Promise<any> {
        return new Promise(async (resolve) => {
            glob(`${this.pathTool.createPath('./build')}/**`, { nodir: true }, (err: any, files: any[]) => {
                if (err) {
                    resolve({
                        status: false,
                        data: []
                    });
                } else {
                    const list: any[] = [];
                    files.forEach((file, index) => {
                        if (cdn.ignore && cdn.ignore.length > 0) {
                            cdn.ignore.forEach((item: any, s: number) => {
                                if (file.indexOf(item.replace('*', '')) == -1) {
                                    const a = file.split('build');
                                    let key = '';
                                    if (cdn.dirname) {
                                        key = `${cdn.dirname}/`;
                                    }
                                    if (cdn.v) {
                                        key = key ? `${key}/${cdn.v}/` : `${cdn.v}/`;
                                    }
                                    if (key) {
                                        key = key + a[1];
                                    } else {
                                        key = a[1];
                                    }
                                    list.push({
                                        path: file,
                                        key: key
                                    });
                                }
                            });
                        } else {
                            const a = file.split('/');
                            let key = '';
                            if (cdn.dirname) {
                                key = `${cdn.dirname}/`;
                            }
                            if (cdn.v) {
                                key = key ? `${key}/${cdn.v}/` : `${cdn.v}/`;
                            }
                            if (key) {
                                key = key + a[a.length - 1];
                            } else {
                                key = a[a.length - 1];
                            }
                            list.push({
                                path: file,
                                key: key
                            });
                        }
                    });
                    resolve({
                        status: true,
                        data: list
                    });
                }
            });
        });
    }
    public upload(cdn: any, list: any[]): Promise<any> {
        return new Promise(async (resolve) => {
            console.log(colors.cyan(`需要上传文件总数：${list.length}`));
            const token = this.uploadTool.getToken(cdn);
            list.forEach((file, index) => {
                this.uploadTool.upload(token, file.key, file, cdn.url, cdn.zone);
            });
            resolve({
                status: true
            });
        });
    }
}
