import qiniu from 'qiniu';
import colors from 'colors';

export class UploadTool {
    public getToken(cdn: any) {
        const mac = new qiniu.auth.digest.Mac(cdn.ak, cdn.sk);
        const options = {
            scope: cdn.bk
        };
        const putPolicy = new qiniu.rs.PutPolicy(options);
        const uploadToken = putPolicy.uploadToken(mac);
        return uploadToken;
    }
    public upload(token: any, key: string, file: string, url: string, zone: string): Promise<any> {
        return new Promise((resolve) => {
            const config: any = new qiniu.conf.Config();
            const qzone: any = qiniu.zone;
            if (zone && qiniu.zone && qzone[zone]) {
                config.zone = qzone[zone];
            }
            const putExtra = new qiniu.form_up.PutExtra();
            const formUploader = new qiniu.form_up.FormUploader(config);
            formUploader.putFile(token, key, file, putExtra, (respErr: any, respBody, respInfo) => {
                if (respErr) {
                    console.log(`错误信息`.red);
                    console.log(colors.yellow(respErr));
                    console.log(``);
                    resolve({
                        status:false
                    })
                }
                if (respInfo) {
                    if (respInfo.statusCode == 200) {
                        console.log(colors.green(`上传 ${url ? url : '~'}/${respBody.key} 完成`));
                    } else {
                        console.log(`Waring code: ${respInfo.statusCode}`.yellow);
                        console.log(colors.white(respBody));
                        console.log(``);
                    }
                    resolve({
                        status:true
                    })
                }
            });
        });
    }
}
